// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockReleases is an autogenerated mock type for the Releases type
type MockReleases struct {
	mock.Mock
}

// CreateRelease provides a mock function with given fields: ctx, release
func (_m *MockReleases) CreateRelease(ctx context.Context, release *models.Release) (*models.Release, error) {
	ret := _m.Called(ctx, release)

	if len(ret) == 0 {
		panic("no return value specified for CreateRelease")
	}

	var r0 *models.Release
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Release) (*models.Release, error)); ok {
		return rf(ctx, release)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Release) *models.Release); ok {
		r0 = rf(ctx, release)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Release)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Release) error); ok {
		r1 = rf(ctx, release)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteRelease provides a mock function with given fields: ctx, release
func (_m *MockReleases) DeleteRelease(ctx context.Context, release *models.Release) error {
	ret := _m.Called(ctx, release)

	if len(ret) == 0 {
		panic("no return value specified for DeleteRelease")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Release) error); ok {
		r0 = rf(ctx, release)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetReleaseByID provides a mock function with given fields: ctx, id
func (_m *MockReleases) GetReleaseByID(ctx context.Context, id string) (*models.Release, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetReleaseByID")
	}

	var r0 *models.Release
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Release, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Release); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Release)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetReleaseByPRN provides a mock function with given fields: ctx, prn
func (_m *MockReleases) GetReleaseByPRN(ctx context.Context, prn string) (*models.Release, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetReleaseByPRN")
	}

	var r0 *models.Release
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.Release, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.Release); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Release)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetReleases provides a mock function with given fields: ctx, input
func (_m *MockReleases) GetReleases(ctx context.Context, input *GetReleasesInput) (*ReleasesResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetReleases")
	}

	var r0 *ReleasesResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetReleasesInput) (*ReleasesResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetReleasesInput) *ReleasesResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*ReleasesResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetReleasesInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateRelease provides a mock function with given fields: ctx, release
func (_m *MockReleases) UpdateRelease(ctx context.Context, release *models.Release) (*models.Release, error) {
	ret := _m.Called(ctx, release)

	if len(ret) == 0 {
		panic("no return value specified for UpdateRelease")
	}

	var r0 *models.Release
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Release) (*models.Release, error)); ok {
		return rf(ctx, release)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Release) *models.Release); ok {
		r0 = rf(ctx, release)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Release)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Release) error); ok {
		r1 = rf(ctx, release)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockReleases creates a new instance of MockReleases. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockReleases(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockReleases {
	mock := &MockReleases{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
